Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/tesselation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -680,8 +689,9 @@
 {
   ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << "," << a.endpoints[1]->node->Name << "," << a.endpoints[2]->node->Name << "]";
-//  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << ","
-//      << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "," << a.endpoints[2]->node->Name << " at " << *a.endpoints[2]->node->node << "]";
+  //  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << ","
+  //      << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "," << a.endpoints[2]->node->Name << " at " << *a.endpoints[2]->node->node << "]";
   return ost;
-};
+}
+;
 
 // ======================================== Polygons on Boundary =================================
@@ -693,5 +703,6 @@
 {
   Info FunctionInfo(__func__);
-};
+}
+;
 
 /** Destructor of BoundaryPolygonSet.
@@ -703,6 +714,7 @@
   Info FunctionInfo(__func__);
   endpoints.clear();
-  Log() << Verbose(1) << "Erasing polygon Nr." << Nr << " itself." << endl;
-};
+  DoLog(1) && (Log() << Verbose(1) << "Erasing polygon Nr." << Nr << " itself." << endl);
+}
+;
 
 /** Calculates the normal vector for this triangle.
@@ -718,10 +730,10 @@
   Vector *TotalNormal = new Vector;
   PointSet::const_iterator Runner[3];
-  for (int i=0;i<3; i++) {
+  for (int i = 0; i < 3; i++) {
     Runner[i] = endpoints.begin();
-    for (int j = 0; j<i; j++) { // go as much further
+    for (int j = 0; j < i; j++) { // go as much further
       Runner[i]++;
       if (Runner[i] == endpoints.end()) {
-        eLog() << Verbose(0) << "There are less than three endpoints in the polygon!" << endl;
+        DoeLog(0) && (eLog() << Verbose(0) << "There are less than three endpoints in the polygon!" << endl);
         performCriticalExit();
       }
@@ -729,20 +741,23 @@
   }
   TotalNormal->Zero();
-  int counter=0;
-  for (; Runner[2] != endpoints.end(); ) {
-    TemporaryNormal.MakeNormalVector((*Runner[0])->node->node, (*Runner[1])->node->node, (*Runner[2])->node->node);
-    for (int i=0;i<3;i++) // increase each of them
+  int counter = 0;
+  for (; Runner[2] != endpoints.end();) {
+    TemporaryNormal = Plane(*((*Runner[0])->node->node),
+                            *((*Runner[1])->node->node),
+                            *((*Runner[2])->node->node)).getNormal();
+    for (int i = 0; i < 3; i++) // increase each of them
       Runner[i]++;
-    TotalNormal->AddVector(&TemporaryNormal);
-  }
-  TotalNormal->Scale(1./(double)counter);
+    (*TotalNormal) += TemporaryNormal;
+  }
+  TotalNormal->Scale(1. / (double) counter);
 
   // make it always point inward (any offset vector onto plane projected onto normal vector suffices)
-  if (TotalNormal->ScalarProduct(&OtherVector) > 0.)
+  if (TotalNormal->ScalarProduct(OtherVector) > 0.)
     TotalNormal->Scale(-1.);
-  Log() << Verbose(1) << "Normal Vector is " << *TotalNormal << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Normal Vector is " << *TotalNormal << "." << endl);
 
   return TotalNormal;
-};
+}
+;
 
 /** Calculates the center point of the triangle.
@@ -756,9 +771,9 @@
   int counter = 0;
   for(PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
-    center->AddVector((*Runner)->node->node);
+    (*center) += (*(*Runner)->node->node);
     counter++;
   }
-  center->Scale(1./(double)counter);
-  Log() << Verbose(1) << "Center is at " << *center << "." << endl;
+  center->Scale(1. / (double) counter);
+  DoLog(1) && (Log() << Verbose(1) << "Center is at " << *center << "." << endl);
 }
 
@@ -771,5 +786,6 @@
   Info FunctionInfo(__func__);
   return ContainsPresentTupel(triangle->endpoints, 3);
-};
+}
+;
 
 /** Checks whether the polygons contains both endpoints of the line.
@@ -781,5 +797,6 @@
   Info FunctionInfo(__func__);
   return ContainsPresentTupel(line->endpoints, 2);
-};
+}
+;
 
 /** Checks whether point is any of the three endpoints this triangle contains.
@@ -790,14 +807,15 @@
 {
   Info FunctionInfo(__func__);
-  for(PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
-    Log() << Verbose(0) << "Checking against " << **Runner << endl;
+  for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
+    DoLog(0) && (Log() << Verbose(0) << "Checking against " << **Runner << endl);
     if (point == (*Runner)) {
-      Log() << Verbose(0) << " Contained." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " Contained." << endl);
       return true;
     }
   }
-  Log() << Verbose(0) << " Not contained." << endl;
+  DoLog(0) && (Log() << Verbose(0) << " Not contained." << endl);
   return false;
-};
+}
+;
 
 /** Checks whether point is any of the three endpoints this triangle contains.
@@ -808,12 +826,13 @@
 {
   Info FunctionInfo(__func__);
-  for(PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++)
+  for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++)
     if (point == (*Runner)->node) {
-      Log() << Verbose(0) << " Contained." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " Contained." << endl);
       return true;
     }
-  Log() << Verbose(0) << " Not contained." << endl;
+  DoLog(0) && (Log() << Verbose(0) << " Not contained." << endl);
   return false;
-};
+}
+;
 
 /** Checks whether given array of \a *Points coincide with polygons's endpoints.
@@ -826,7 +845,7 @@
   Info FunctionInfo(__func__);
   int counter = 0;
-  Log() << Verbose(1) << "Polygon is " << *this << endl;
-  for(int i=0;i<dim;i++) {
-    Log() << Verbose(1) << " Testing endpoint " << *Points[i] << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Polygon is " << *this << endl);
+  for (int i = 0; i < dim; i++) {
+    DoLog(1) && (Log() << Verbose(1) << " Testing endpoint " << *Points[i] << endl);
     if (ContainsBoundaryPoint(Points[i])) {
       counter++;
@@ -838,5 +857,6 @@
   else
     return false;
-};
+}
+;
 
 /** Checks whether given PointList coincide with polygons's endpoints.
@@ -848,7 +868,7 @@
   Info FunctionInfo(__func__);
   size_t counter = 0;
-  Log() << Verbose(1) << "Polygon is " << *this << endl;
-  for(PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
-    Log() << Verbose(1) << " Testing endpoint " << **Runner << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Polygon is " << *this << endl);
+  for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++) {
+    DoLog(1) && (Log() << Verbose(1) << " Testing endpoint " << **Runner << endl);
     if (ContainsBoundaryPoint(*Runner))
       counter++;
@@ -859,5 +879,6 @@
   else
     return false;
-};
+}
+;
 
 /** Checks whether given set of \a *Points coincide with polygons's endpoints.
@@ -867,6 +888,7 @@
 bool BoundaryPolygonSet::ContainsPresentTupel(const BoundaryPolygonSet * const P) const
 {
-  return ContainsPresentTupel((const PointSet)P->endpoints);
-};
+  return ContainsPresentTupel((const PointSet) P->endpoints);
+}
+;
 
 /** Gathers all the endpoints' triangles in a unique set.
@@ -876,21 +898,22 @@
 {
   Info FunctionInfo(__func__);
-  pair <TriangleSet::iterator, bool> Tester;
+  pair<TriangleSet::iterator, bool> Tester;
   TriangleSet *triangles = new TriangleSet;
 
-  for(PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++)
-    for(LineMap::const_iterator Walker = (*Runner)->lines.begin(); Walker != (*Runner)->lines.end(); Walker++)
-      for(TriangleMap::const_iterator Sprinter = (Walker->second)->triangles.begin(); Sprinter != (Walker->second)->triangles.end(); Sprinter++) {
+  for (PointSet::const_iterator Runner = endpoints.begin(); Runner != endpoints.end(); Runner++)
+    for (LineMap::const_iterator Walker = (*Runner)->lines.begin(); Walker != (*Runner)->lines.end(); Walker++)
+      for (TriangleMap::const_iterator Sprinter = (Walker->second)->triangles.begin(); Sprinter != (Walker->second)->triangles.end(); Sprinter++) {
         //Log() << Verbose(0) << " Testing triangle " << *(Sprinter->second) << endl;
         if (ContainsBoundaryTriangle(Sprinter->second)) {
           Tester = triangles->insert(Sprinter->second);
           if (Tester.second)
-            Log() << Verbose(0) << "Adding triangle " << *(Sprinter->second) << endl;
+            DoLog(0) && (Log() << Verbose(0) << "Adding triangle " << *(Sprinter->second) << endl);
         }
       }
 
-  Log() << Verbose(1) << "The Polygon of " << endpoints.size() << " endpoints has " << triangles->size() << " unique triangles in total." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "The Polygon of " << endpoints.size() << " endpoints has " << triangles->size() << " unique triangles in total." << endl);
   return triangles;
-};
+}
+;
 
 /** Fills the endpoints of this polygon from the triangles attached to \a *line.
@@ -901,18 +924,19 @@
 {
   Info FunctionInfo(__func__);
-  pair <PointSet::iterator, bool> Tester;
+  pair<PointSet::iterator, bool> Tester;
   if (line == NULL)
     return false;
-  Log() << Verbose(1) << "Filling polygon from line " << *line << endl;
-  for(TriangleMap::const_iterator Runner = line->triangles.begin(); Runner != line->triangles.end(); Runner++) {
-    for (int i=0;i<3;i++) {
+  DoLog(1) && (Log() << Verbose(1) << "Filling polygon from line " << *line << endl);
+  for (TriangleMap::const_iterator Runner = line->triangles.begin(); Runner != line->triangles.end(); Runner++) {
+    for (int i = 0; i < 3; i++) {
       Tester = endpoints.insert((Runner->second)->endpoints[i]);
       if (Tester.second)
-        Log() << Verbose(1) << "  Inserting endpoint " << *((Runner->second)->endpoints[i]) << endl;
+        DoLog(1) && (Log() << Verbose(1) << "  Inserting endpoint " << *((Runner->second)->endpoints[i]) << endl);
     }
   }
 
   return true;
-};
+}
+;
 
 /** output operator for BoundaryPolygonSet.
@@ -923,13 +947,14 @@
 {
   ost << "[" << a.Nr << "|";
-  for(PointSet::const_iterator Runner = a.endpoints.begin(); Runner != a.endpoints.end();) {
-   ost << (*Runner)->node->Name;
-   Runner++;
-   if (Runner != a.endpoints.end())
-     ost << ",";
-  }
-  ost<< "]";
+  for (PointSet::const_iterator Runner = a.endpoints.begin(); Runner != a.endpoints.end();) {
+    ost << (*Runner)->node->Name;
+    Runner++;
+    if (Runner != a.endpoints.end())
+      ost << ",";
+  }
+  ost << "]";
   return ost;
-};
+}
+;
 
 // =========================================================== class TESSELPOINT ===========================================
@@ -942,6 +967,7 @@
   node = NULL;
   nr = -1;
-  Name =  NULL;
-};
+  Name = NULL;
+}
+;
 
 /** Destructor for class TesselPoint.
@@ -950,70 +976,156 @@
 {
   //Info FunctionInfo(__func__);
-};
+}
+;
 
 /** Prints LCNode to screen.
  */
-ostream & operator << (ostream &ost, const TesselPoint &a)
+ostream & operator <<(ostream &ost, const TesselPoint &a)
 {
   ost << "[" << (a.Name) << "|" << a.Name << " at " << *a.node << "]";
   return ost;
-};
+}
+;
 
 /** Prints LCNode to screen.
  */
-ostream & TesselPoint::operator << (ostream &ost)
-{
-	Info FunctionInfo(__func__);
+ostream & TesselPoint::operator <<(ostream &ost)
+{
+  Info FunctionInfo(__func__);
   ost << "[" << (nr) << "|" << this << "]";
   return ost;
+}
+;
+
+// =========================================================== class POINTCLOUD ============================================
+
+/** Constructor of class PointCloud.
+ */
+PointCloud::PointCloud()
+{
+  //Info FunctionInfo(__func__);
+}
+;
+
+/** Destructor for class PointCloud.
+ */
+PointCloud::~PointCloud()
+{
+  //Info FunctionInfo(__func__);
+}
+;
+
+// ============================ CandidateForTesselation =============================
+
+/** Constructor of class CandidateForTesselation.
+ */
+CandidateForTesselation::CandidateForTesselation(BoundaryLineSet* line) :
+  BaseLine(line), ThirdPoint(NULL), T(NULL), ShortestAngle(2. * M_PI), OtherShortestAngle(2. * M_PI)
+{
+  Info FunctionInfo(__func__);
+}
+;
+
+/** Constructor of class CandidateForTesselation.
+ */
+CandidateForTesselation::CandidateForTesselation(TesselPoint *candidate, BoundaryLineSet* line, BoundaryPointSet* point, Vector OptCandidateCenter, Vector OtherOptCandidateCenter) :
+  BaseLine(line), ThirdPoint(point), T(NULL), ShortestAngle(2. * M_PI), OtherShortestAngle(2. * M_PI)
+{
+	Info FunctionInfo(__func__);
+  OptCenter = OptCandidateCenter;
+  OtherOptCenter = OtherOptCandidateCenter;
 };
 
 
-// =========================================================== class POINTCLOUD ============================================
-
-/** Constructor of class PointCloud.
- */
-PointCloud::PointCloud()
-{
-	//Info FunctionInfo(__func__);
-};
-
-/** Destructor for class PointCloud.
- */
-PointCloud::~PointCloud()
-{
-	//Info FunctionInfo(__func__);
-};
-
-// ============================ CandidateForTesselation =============================
-
-/** Constructor of class CandidateForTesselation.
- */
-CandidateForTesselation::CandidateForTesselation (BoundaryLineSet* line) :
-  BaseLine(line),
-  ShortestAngle(2.*M_PI),
-  OtherShortestAngle(2.*M_PI)
-{
-	Info FunctionInfo(__func__);
-};
-
-
-/** Constructor of class CandidateForTesselation.
- */
-CandidateForTesselation::CandidateForTesselation (TesselPoint *candidate, BoundaryLineSet* line, Vector OptCandidateCenter, Vector OtherOptCandidateCenter) :
-    BaseLine(line),
-    ShortestAngle(2.*M_PI),
-    OtherShortestAngle(2.*M_PI)
-{
-	Info FunctionInfo(__func__);
-  OptCenter.CopyVector(&OptCandidateCenter);
-  OtherOptCenter.CopyVector(&OtherOptCandidateCenter);
-};
-
 /** Destructor for class CandidateForTesselation.
  */
-CandidateForTesselation::~CandidateForTesselation() {
-  BaseLine = NULL;
-};
+CandidateForTesselation::~CandidateForTesselation()
+{
+}
+;
+
+/** Checks validity of a given sphere of a candidate line.
+ * Sphere must touch all candidates and the baseline endpoints and there must be no other atoms inside.
+ * \param RADIUS radius of sphere
+ * \param *LC LinkedCell structure with other atoms
+ * \return true - sphere is valid, false - sphere contains other points
+ */
+bool CandidateForTesselation::CheckValidity(const double RADIUS, const LinkedCell *LC) const
+{
+  Info FunctionInfo(__func__);
+
+  const double radiusSquared = RADIUS * RADIUS;
+  list<const Vector *> VectorList;
+  VectorList.push_back(&OptCenter);
+  //VectorList.push_back(&OtherOptCenter);  // don't check the other (wrong) center
+
+  if (!pointlist.empty())
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Checking whether sphere contains candidate list and baseline " << *BaseLine->endpoints[0] << "<->" << *BaseLine->endpoints[1] << " only ..." << endl);
+  else
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Checking whether sphere with no candidates contains baseline " << *BaseLine->endpoints[0] << "<->" << *BaseLine->endpoints[1] << " only ..." << endl);
+  // check baseline for OptCenter and OtherOptCenter being on sphere's surface
+  for (list<const Vector *>::const_iterator VRunner = VectorList.begin(); VRunner != VectorList.end(); ++VRunner) {
+    for (int i = 0; i < 2; i++) {
+      const double distance = fabs((*VRunner)->DistanceSquared(*BaseLine->endpoints[i]->node->node) - radiusSquared);
+      if (distance > HULLEPSILON) {
+        DoeLog(1) && (eLog() << Verbose(1) << "Endpoint " << *BaseLine->endpoints[i] << " is out of sphere at " << *(*VRunner) << " by " << distance << "." << endl);
+        return false;
+      }
+    }
+  }
+
+  // check Candidates for OptCenter and OtherOptCenter being on sphere's surface
+  for (TesselPointList::const_iterator Runner = pointlist.begin(); Runner != pointlist.end(); ++Runner) {
+    const TesselPoint *Walker = *Runner;
+    for (list<const Vector *>::const_iterator VRunner = VectorList.begin(); VRunner != VectorList.end(); ++VRunner) {
+      const double distance = fabs((*VRunner)->DistanceSquared(*Walker->node) - radiusSquared);
+      if (distance > HULLEPSILON) {
+        DoeLog(1) && (eLog() << Verbose(1) << "Candidate " << *Walker << " is out of sphere at " << *(*VRunner) << " by " << distance << "." << endl);
+        return false;
+      } else {
+        DoLog(1) && (Log() << Verbose(1) << "Candidate " << *Walker << " is inside by " << distance << "." << endl);
+      }
+    }
+  }
+
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Checking whether sphere contains no others points ..." << endl);
+  bool flag = true;
+  for (list<const Vector *>::const_iterator VRunner = VectorList.begin(); VRunner != VectorList.end(); ++VRunner) {
+    // get all points inside the sphere
+    TesselPointList *ListofPoints = LC->GetPointsInsideSphere(RADIUS, (*VRunner));
+
+    DoLog(1) && (Log() << Verbose(1) << "The following atoms are inside sphere at " << OtherOptCenter << ":" << endl);
+    for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
+      DoLog(1) && (Log() << Verbose(1) << "  " << *(*Runner) << " with distance " << (*Runner)->node->distance(OtherOptCenter) << "." << endl);
+
+    // remove baseline's endpoints and candidates
+    for (int i = 0; i < 2; i++) {
+      DoLog(1) && (Log() << Verbose(1) << "INFO: removing baseline tesselpoint " << *BaseLine->endpoints[i]->node << "." << endl);
+      ListofPoints->remove(BaseLine->endpoints[i]->node);
+    }
+    for (TesselPointList::const_iterator Runner = pointlist.begin(); Runner != pointlist.end(); ++Runner) {
+      DoLog(1) && (Log() << Verbose(1) << "INFO: removing candidate tesselpoint " << *(*Runner) << "." << endl);
+      ListofPoints->remove(*Runner);
+    }
+    if (!ListofPoints->empty()) {
+      DoeLog(1) && (eLog() << Verbose(1) << "CheckValidity: There are still " << ListofPoints->size() << " points inside the sphere." << endl);
+      flag = false;
+      DoeLog(1) && (eLog() << Verbose(1) << "External atoms inside of sphere at " << *(*VRunner) << ":" << endl);
+      for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
+        DoeLog(1) && (eLog() << Verbose(1) << "  " << *(*Runner) << endl);
+    }
+    delete (ListofPoints);
+
+    // check with animate_sphere.tcl VMD script
+    if (ThirdPoint != NULL) {
+      DoLog(1) && (Log() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " " << ThirdPoint->Nr + 1 << " " << RADIUS << " " << OldCenter[0] << " " << OldCenter[1] << " " << OldCenter[2] << " " << (*VRunner)->at(0) << " " << (*VRunner)->at(1) << " " << (*VRunner)->at(2) << endl);
+    } else {
+      DoLog(1) && (Log() << Verbose(1) << "Check by: ... missing third point ..." << endl);
+      DoLog(1) && (Log() << Verbose(1) << "Check by: animate_sphere 0 " << BaseLine->endpoints[0]->Nr + 1 << " " << BaseLine->endpoints[1]->Nr + 1 << " ??? " << RADIUS << " " << OldCenter[0] << " " << OldCenter[1] << " " << OldCenter[2] << " " << (*VRunner)->at(0) << " " << (*VRunner)->at(1) << " " << (*VRunner)->at(2) << endl);
+    }
+  }
+  return flag;
+}
+;
 
 /** output operator for CandidateForTesselation.
@@ -1021,5 +1133,5 @@
  * \param &a boundary line
  */
-ostream & operator <<(ostream &ost, const  CandidateForTesselation &a)
+ostream & operator <<(ostream &ost, const CandidateForTesselation &a)
 {
   ost << "[" << a.BaseLine->Nr << "|" << a.BaseLine->endpoints[0]->node->Name << "," << a.BaseLine->endpoints[1]->node->Name << "] with ";
@@ -1034,10 +1146,10 @@
     for (TesselPointList::const_iterator Runner = a.pointlist.begin(); Runner != a.pointlist.end(); Runner++)
       ost << *(*Runner) << " ";
-    ost << " at angle " << (a.ShortestAngle)<< ".";
+    ost << " at angle " << (a.ShortestAngle) << ".";
   }
 
   return ost;
-};
-
+}
+;
 
 // =========================================================== class TESSELATION ===========================================
@@ -1046,12 +1158,7 @@
  */
 Tesselation::Tesselation() :
-  PointsOnBoundaryCount(0),
-  LinesOnBoundaryCount(0),
-  TrianglesOnBoundaryCount(0),
-  LastTriangle(NULL),
-  TriangleFilesWritten(0),
-  InternalPointer(PointsOnBoundary.begin())
-{
-	Info FunctionInfo(__func__);
+  PointsOnBoundaryCount(0), LinesOnBoundaryCount(0), TrianglesOnBoundaryCount(0), LastTriangle(NULL), TriangleFilesWritten(0), InternalPointer(PointsOnBoundary.begin())
+{
+  Info FunctionInfo(__func__);
 }
 ;
@@ -1062,6 +1169,6 @@
 Tesselation::~Tesselation()
 {
-	Info FunctionInfo(__func__);
-  Log() << Verbose(0) << "Free'ing TesselStruct ... " << endl;
+  Info FunctionInfo(__func__);
+  DoLog(0) && (Log() << Verbose(0) << "Free'ing TesselStruct ... " << endl);
   for (TriangleMap::iterator runner = TrianglesOnBoundary.begin(); runner != TrianglesOnBoundary.end(); runner++) {
     if (runner->second != NULL) {
@@ -1069,7 +1176,7 @@
       runner->second = NULL;
     } else
-      eLog() << Verbose(1) << "The triangle " << runner->first << " has already been free'd." << endl;
-  }
-  Log() << Verbose(0) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl;
+      DoeLog(1) && (eLog() << Verbose(1) << "The triangle " << runner->first << " has already been free'd." << endl);
+  }
+  DoLog(0) && (Log() << Verbose(0) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl);
 }
 ;
@@ -1077,66 +1184,72 @@
 /** PointCloud implementation of GetCenter
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 Vector * Tesselation::GetCenter(ofstream *out) const
 {
-	Info FunctionInfo(__func__);
-  Vector *Center = new Vector(0.,0.,0.);
-  int num=0;
+  Info FunctionInfo(__func__);
+  Vector *Center = new Vector(0., 0., 0.);
+  int num = 0;
   for (GoToFirst(); (!IsEnd()); GoToNext()) {
-    Center->AddVector(GetPoint()->node);
+    (*Center) += (*GetPoint()->node);
     num++;
   }
-  Center->Scale(1./num);
+  Center->Scale(1. / num);
   return Center;
-};
+}
+;
 
 /** PointCloud implementation of GoPoint
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 TesselPoint * Tesselation::GetPoint() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   return (InternalPointer->second->node);
-};
+}
+;
 
 /** PointCloud implementation of GetTerminalPoint.
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 TesselPoint * Tesselation::GetTerminalPoint() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   PointMap::const_iterator Runner = PointsOnBoundary.end();
   Runner--;
   return (Runner->second->node);
-};
+}
+;
 
 /** PointCloud implementation of GoToNext.
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 void Tesselation::GoToNext() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   if (InternalPointer != PointsOnBoundary.end())
     InternalPointer++;
-};
+}
+;
 
 /** PointCloud implementation of GoToPrevious.
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 void Tesselation::GoToPrevious() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   if (InternalPointer != PointsOnBoundary.begin())
     InternalPointer--;
-};
+}
+;
 
 /** PointCloud implementation of GoToFirst.
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 void Tesselation::GoToFirst() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   InternalPointer = PointsOnBoundary.begin();
-};
+}
+;
 
 /** PointCloud implementation of GoToLast.
@@ -1145,27 +1258,29 @@
 void Tesselation::GoToLast() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   InternalPointer = PointsOnBoundary.end();
   InternalPointer--;
-};
+}
+;
 
 /** PointCloud implementation of IsEmpty.
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 bool Tesselation::IsEmpty() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   return (PointsOnBoundary.empty());
-};
+}
+;
 
 /** PointCloud implementation of IsLast.
  * Uses PointsOnBoundary and STL stuff.
- */   
+ */
 bool Tesselation::IsEnd() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   return (InternalPointer == PointsOnBoundary.end());
-};
-
+}
+;
 
 /** Gueses first starting triangle of the convex envelope.
@@ -1176,5 +1291,5 @@
 void Tesselation::GuessStartingTriangle()
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   // 4b. create a starting triangle
   // 4b1. create all distances
@@ -1186,24 +1301,21 @@
 
   // with A chosen, take each pair B,C and sort
-  if (A != PointsOnBoundary.end())
-    {
-      B = A;
-      B++;
-      for (; B != PointsOnBoundary.end(); B++)
-        {
-          C = B;
-          C++;
-          for (; C != PointsOnBoundary.end(); C++)
-            {
-              tmp = A->second->node->node->DistanceSquared(B->second->node->node);
-              distance = tmp * tmp;
-              tmp = A->second->node->node->DistanceSquared(C->second->node->node);
-              distance += tmp * tmp;
-              tmp = B->second->node->node->DistanceSquared(C->second->node->node);
-              distance += tmp * tmp;
-              DistanceMMap.insert(DistanceMultiMapPair(distance, pair<PointMap::iterator, PointMap::iterator> (B, C)));
-            }
-        }
-    }
+  if (A != PointsOnBoundary.end()) {
+    B = A;
+    B++;
+    for (; B != PointsOnBoundary.end(); B++) {
+      C = B;
+      C++;
+      for (; C != PointsOnBoundary.end(); C++) {
+        tmp = A->second->node->node->DistanceSquared(*B->second->node->node);
+        distance = tmp * tmp;
+        tmp = A->second->node->node->DistanceSquared(*C->second->node->node);
+        distance += tmp * tmp;
+        tmp = B->second->node->node->DistanceSquared(*C->second->node->node);
+        distance += tmp * tmp;
+        DistanceMMap.insert(DistanceMultiMapPair(distance, pair<PointMap::iterator, PointMap::iterator> (B, C)));
+      }
+    }
+  }
   //    // listing distances
   //    Log() << Verbose(1) << "Listing DistanceMMap:";
